﻿using Syncfusion.SfChart.XForms;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Xamarin.Forms;

namespace SimpleSample
{
    public class ViewModel : BindableObject
    {
		public ObservableCollection<Model> LiveData { get; set; }

        public ObservableCollection<Color> Colors1 { get; set; }
		public ObservableCollection<Color> Colors2 { get; set; }
		public ObservableCollection<Color> Colors3 { get; set; }

        ChartSeries Series1;
		ChartSeries Series2;
		ChartSeries Series3;

        public ViewModel()
        {

        }
		public ViewModel(ChartSeries series1, ChartSeries series2, ChartSeries series3)
        {
			LiveData = new ObservableCollection<Model>();
	
            Colors1 = new ObservableCollection<Color>();
			Colors2 = new ObservableCollection<Color>();
			Colors3 = new ObservableCollection<Color>();
            Series1 = series1;
			Series2 = series2;
			Series3 = series3;

            for (int i = 0; i < 10; i++)
            {
                var yValue = random.Next(0, 300);
				var yValue2 = random.Next(0, 300);
				var yValue3 = random.Next(0, 300);

				LiveData.Add(new Model(i, yValue,yValue2,yValue3));

                if (yValue >= 0 && yValue < 100)
                    Colors1.Add(Color.Red);
                else if (yValue >= 100 && yValue < 200)
                    Colors1.Add(Color.Green);
                else if (yValue >= 200 && yValue < 300)
                    Colors1.Add(Color.Yellow);

				if (yValue2 >= 0 && yValue2 < 100)
					Colors2.Add(Color.Red);
				else if (yValue2 >=100  && yValue2 < 200)
					Colors2.Add(Color.Green);
				else if (yValue2 >= 200 && yValue2 < 300)
					Colors2.Add(Color.Yellow);


				if (yValue3 >= 0 && yValue3 < 100)
					Colors3.Add(Color.Red);
				else if (yValue3 >= 100 && yValue3 < 200)
					Colors3.Add(Color.Green);
				else if (yValue3 >= 200 && yValue3 < 300)
					Colors3.Add(Color.Yellow);
            }

            LoadData();
        }

        int xValue = 0;
        double yValue;
		double yValue2;
		double yValue3;
        Random random = new Random();
        public void LoadData()
        {
            Device.StartTimer(new TimeSpan(0, 0, 0, 0, 500), () =>
            {
                if (xValue < 1000)
                {
                    int index = random.Next(0, 10);
                    
					yValue = random.Next(0, 300);
					yValue2 = random.Next(0, 300);
					yValue3 = random.Next(0, 300);

					LiveData[index].YValue1 = yValue;
					LiveData[index].YValue2 = yValue2;
					LiveData[index].YValue3 = yValue3;

                    if (yValue >= 0 && yValue < 100)
                        Colors1[index] = Color.Red;
                    else if (yValue >= 100 && yValue < 200)
                        Colors1[index] = Color.Green;
                    else if (yValue >= 200 && yValue < 300)
                        Colors1[index] = Color.Yellow;


					if (yValue2 >= 0 && yValue2 < 100)
						Colors2[index] = Color.Red;
					else if (yValue2 >= 100 && yValue2 < 200)
						Colors2[index] = Color.Green;
					else if (yValue2 >= 200 && yValue2 < 300)
						Colors2[index] = Color.Yellow;

					if (yValue3 >= 0 && yValue3 < 100)
						Colors3[index] = Color.Red;
					else if (yValue3 >= 100 && yValue3 < 200)
						Colors3[index] = Color.Green;
					else if (yValue3 >= 200 && yValue3 < 300)
						Colors3[index] = Color.Yellow;

                    List<Color> LColors1 = new List<Color>(Colors1);
					List<Color> LColors2 = new List<Color>(Colors2);
					List<Color> LColors3 = new List<Color>(Colors3);

                   Series1.ColorModel.Palette = ChartColorPalette.Custom;
                   Series1.ColorModel.CustomBrushes = LColors1;

					Series2.ColorModel.Palette = ChartColorPalette.Custom;
					Series2.ColorModel.CustomBrushes = LColors2;

					Series3.ColorModel.Palette = ChartColorPalette.Custom;
					Series3.ColorModel.CustomBrushes = LColors3;

                    xValue++;

                    return true;
                }

                return false;
            });
        }
    }
}
